﻿using System.ComponentModel.Composition;
using System.Windows.Media;
using Microsoft.VisualStudio.Text.Classification;
using Microsoft.VisualStudio.Utilities;

namespace HQLAddin.Highlighting.Formatters
{
	/// <summary>
	/// Defines the keyword editor format for the hbm editor.
	/// </summary>
	[Export(typeof(EditorFormatDefinition))]
	[ClassificationType(ClassificationTypeNames = Name)]
	[Name(Name)]
	[UserVisible(true)] //this should be visible to the end user
	[Order(Before = Priority.Default)] //set the priority to be after the default classifiers
	internal sealed class KeywordFormat : ClassificationFormatDefinition
	{

		public const string Name = "KeywordFormat";

		/// <summary>
		/// Defines the visual format for the "EditorClassifier1" classification type
		/// </summary>
		public KeywordFormat()
		{
			DisplayName = Name;
			ForegroundColor = Colors.Blue;
		}
	}
}